% Type inference for the second-order polymorphic
% lambda calculus.  This includes a generically typed
% let (inherited from tp_ml).

module tp_poly.

import tp_simple tp_polytypes tp_types.

termtype_e (ll U) (ll V) Alpha E :- !,
   Alpha = (dd Beta),
   (pi Theta\ (termtype_e (U Theta) (V Theta) (Beta Theta) E)).

termtype_e (U &&    ) (V & Gamma) Alpha E :- !,
  Alpha = (Beta Gamma),
  termtype_e U V (dd Beta) E.

termtype_e (U & Gamma) (V & Gamma) Alpha E :- !,
  Alpha = (Beta Gamma),
  termtype_e U V (dd Beta) E.
