% Type inference for the second-order polymorphic
% lambda calculus.  This includes a generically typed
% let (inherited from tp_ml).

module tp_poly.

import tp_simple tp_polytypes tp_types.

termtype (ll U) (ll V) Alpha :- !,
   Alpha = (dd Beta),
   (pi Theta\ (termtype (U Theta) (V Theta) (Beta Theta))).

termtype (U &&    ) (V & Gamma) Alpha :- !,
  Alpha = (Beta Gamma),
  termtype U V (dd Beta).

termtype (U & Gamma) (V & Gamma) Alpha :- !,
  Alpha = (Beta Gamma),
  termtype U V (dd Beta).
