% The language extension for the second-order
% polymorphic lambda calculus
% This is provided separately so it can be imported
% by the example file.

module tp_polytypes.

infix   120 &	yfx.		% left assoc: type application.
postfix 120 &&  yf.		% omitted type application.

type  dd        (tp -> tp) -> tp.	       % universal type constructor.

type  ll        (tp -> term) -> term.	       % type abstraction.
type  &		term -> tp -> term.	       % type application.
type  &&	term -> term.		       % type omitted.
